# x, a  matrix to PCA
# pca.color the color object to use for the plot and the legend
# output function: compiles a path according to choices
#
# Author: youssefd
###############################################################################

make.pca.plot <- function(x, pca.color, output, output.device){
	# column wise centring and scaling | no centring will make the 1 component reflect the mean ?
	# since it's column wise, the centring will remove the effect of a category
	# being more abundant than the other but the relation among species to that variable will be the same
	x.pca <- prcomp(x, center = T, scale = T)
	x.legend <- list(
			color = c(pca.color$colors, unlist(pca.color$color.keys)),
			text = c(paste(1:length(rownames(x.pca$x)), rownames(x.pca$x)), rownames(pca.color$color.keys))
	)
	

	# put in a try catch
	tryCatch({
				output.device(output)
				pcaplot(x.pca, choices = c(1, 2), pca.color, 1:length(rownames(x.pca$x)), x.legend)
			},
			error = function (e) {
				stop(e)
			},
			finally = dev.off()
	);
	
	### PCA-plots ####
	#for(choice in list(choice1 = c(1, 2), choice2 = c(1, 3), choice3 = c(2, 3))){
		# scfa average	
	#	pdf(output)
	#	pcaplot(x.pca, choices = choice, pca.color, 1:length(rownames(x.pca$x)), x.legend)
	#	dev.off()
		# try catch
	#}
	
	x <- 100
	y <- 15
	step <- 10
	# every 5 lines move x by 100: i %/% 5 (modulo)
	svg <- ""
	
	for (i in 1:length(rownames(x.pca$x))) {
		svg <-paste(svg, "<text fill=\"", substr(pca.color$colors[i], 1, 7), "\" font-family=\"sans-serif\" font-size=\"12\" x=\"", ((((i  %/% step) + 1) * 1.5 * x) + 30 - x), "\" y=\"", 
				(((i %% step) + 1) * y), "\" style=\"text-anchor: central;\">", sep= "")
		svg <- paste(svg, paste(i, rownames(x.pca$x)[i]), sep = "");
		svg <- paste(svg, "</text>\n", sep = "")
	}
	svg
}
