# x: a 3-column data matrix
# main: Main title
# colors: a vector of colors to match each row
# color.keys: color keys for the legend
# row.names.color.keys: names for color keys
# output: path to output
# output.device: the device to use lieke png, pdf ...
# Author: youssefd
###############################################################################

make.triplot <- function(x, main, colors, color.keys, row.names.color.keys, output, output.device, ...){
	
	color.keys = as.data.frame(color.keys, stringsAsFactors = FALSE)
	row.names(color.keys) <- row.names.color.keys
	colnames(color.keys) <- "color"
	colorsObject <- list(colors = colors, color.keys = color.keys)
	
	# put in a try catch
	tryCatch({
				output.device(filename = output, ...)
				triangle.plot(x, colorsObject, main)
			},
			error = function (e) {
				stop(e)
			},
			finally = dev.off()
	);
}
