# TODO: Add comment
# 
# Author: youssefd
###############################################################################
pcaplot <- function(x, colors, choices, names, legend, ...){  
	
	# TODO add validation for legend
	
	## hack for the legend
	layout(matrix(c(1,2), nrow = 1), widths = c(0.7, 0.3))
	
	if (missing(choices)) {
		choices = c(1, 2)
	} else {
		# validate
		if ((length(choices) != 2) || (length(unique(choices)) != 2)) {
			stop("Choices must be two different components")
		}
	}
	
	if (missing(names)) {
		names <- rownames(x$x)
	}
	
	x.var <- (x$sdev)^2
	x.var.proportions <- x.var/(sum(x.var))
	
	
	# Compute de min/max of new coordinates
	xmin <- min(x$x[, choices[1]])
	xmax <- max(x$x[, choices[1]])
	ymin <- min(x$x[, choices[2]])
	ymax <- max(x$x[, choices[2]])
	par(lwd = 3)
	plot(c(xmin, xmax), c(ymin, ymax), col = "white",
			xlab = paste("Comp", choices[1], " (", signif(x.var.proportions[choices[1]], 3), "%)"),
			ylab = paste("Comp", choices[2], " (", signif(x.var.proportions[choices[2]], 3), "%)"),
			font.axis = 2, font.lab = 2, font.main = 2, ...
	)
	abline(v = 0, lty = 2)
	abline(h = 0, lty = 2)
	# Plot the points with colors 
	text(x$x[, choices[1]], x$x[, choices[2]], names, col = colors$colors) 
	
	# Compute and apply a re-scaling for the arrows of old components # xl.min for min of xloadings,...
	xl.min <- min(0, min(x$rotation[, choices[1]]))
	xl.max <- max(0, max(x$rotation[, choices[1]]))
	yl.min <- min(0, min(x$rotation[, choices[2]]))
	yl.max <- max(0, max(x$rotation[, choices[2]]))
	xl.scale <- max(abs(xmax), abs(xmin)) / max(abs(xl.max), abs(xl.min)) * 0.75
	# 0.75 factor is leave some place for the text 
	yl.scale <- max(abs(ymax), abs(ymin)) / max(abs(yl.max), abs(yl.min)) * 0.75 #Draw old components 
	arrows(rep(0, 100), rep(0, 100), x$rotation[, choices[1]] * xl.scale, x$rotation[, choices[2]] * yl.scale) 
	# Names of old components 
	text(x$rotation[, choices[1]] * xl.scale * 1.1, x$rotation[, choices[2]] * yl.scale * 1.1, rownames(x$rotation), font = 2, cex = 1.2)
	
	## legend hack-start 
	
	par(mar = c(0, 0, 0, 0) + 0.1)
	plot(1:3, 1:3, pch = 1, lty = 1, ylim=c(-2,2), type = "n", axes = FALSE, ann = FALSE)
	
	# phylum only
	legend(1, 1, legend = c(row.names(colors$color.keys)),
			text.col = c(colors$color.keys$color, text.width = 2)
	)
	## legend(1, 1, legend = legend$text,
	##         text.col = c(legend$color, text.width = 2)
	## )
	## legend hack-stop
}

