# X is a 3 column matrix where each row is a sample/item and
# the columns contain the abundance of the features plotted on the 
# triangle
# 
# Add an R script that generates the data
## generate a matrix with 6 entries
# dat <- as.data.frame(matrix(sample.int(18), nrow=6), row.names = c("a", "b", "c", "d", "e", "f"))
# colnames(dat) <- c("F1", "F2", "F3")

## the colors should match the rows
#
#
# colors = c("#FF0F00", "#500000", "#0F0000", "#FF00FF", "#FFF00F", "#F0770F")
# color.keys = as.data.frame(colors, stringsAsFactors = FALSE) 
# row.names(color.keys) <- row.names(dat) 
# colnames(color.keys) <- "color"
#
# colors <- list(colors = colors, color.keys = color.keys)
# triangle.plot(dat, colors)
#
#library(OmixeR);dat <- as.data.frame(matrix(sample.int(18), nrow=6), row.names = c("a", "b", "c", "d", "e", "f"));make.groupless.triplot(dat, main="", "/tmp/sometest.svg", svg)
#
# Author: youssefd
###############################################################################

triangle.plot <- function(x, colors, ...) {
	# proporionalize by row
	x <- x/rowSums(x)
	par(bg="#FFFFFF", lwd = 1, xpd = TRUE)
	
	# if colors are defined use color to label the dots on the plot and define th legend
	if(!is.null(colors)){
		#triax.plot(x, pch=16, col.symbols = colors$colors, mar = par()$mar + c(0, 0, 0, 10), show.grid = FALSE, col.grid = "black", lty.grid = 1, ...)
		triax.plot(x, pch=16, col.symbols = colors$colors, mar=c(5,3,2,2)+0.1, show.grid = FALSE, ...)
		triax.abline(l=0.5)
		triax.abline(r=0.5)
		triax.abline(b=0.5)
		triax.points(x, pch=16, col.symbols = colors$colors, mar=c(5,3,2,2)+0.1)
		legend(-0.1, 1, pch = 16, legend = rownames(colors$color.keys), col = colors$color.keys[, "color"], inset=0.05)
		
	} else {
		# use sample names in legend and index the dots on the plot
		legend.names <- c()
		for (i in 1:nrow(x)){
			legend.names <- c(legend.names, paste(i, rownames(x)[i], sep = " - ")) 
		}
		#topo.colors
		colors <- rainbow(nrow(x))
		
		triax.plot(x, pch=16, col.symbols = colors, mar=c(5,3,2,2)+0.1, show.grid = FALSE, ...)
		triax.abline(l=0.5)
		triax.abline(r=0.5)
		triax.abline(b=0.5)
		legend(-0.1, 1, pch = 16, legend = rownames(x), col = colors, inset=0.05)
		triax.points(x, pch=16, col.symbols = colors, mar=c(5,3,2,2)+0.1)
	}
}
